/****************************************************************
*  Name    : ConfigurazioneText									*
*  Author  : Ingg. Alessandro e Tommaso Giusto       			*
*  Notice  : Copyright 2013 All Rights Reserved                 *
*  Date    : 05/10/2013                                         *
*  Notes   : Classe memorizzazione config. etichette testo		*
*          :													*
****************************************************************/

// Definizione Package
package blackProject.ShieldIOControl;

// Inclusione librerie
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;

// Definizione classe ConfigurazioneText
public class ConfigurazioneText {
	private static final String ConfigurazioneTextPrefs = "ConfigurazioneText";
	private static final int mode = Activity.MODE_PRIVATE;
		
	// Stringhe etichette testo Uscite
	public static String TextUscite[] = {"","","","","","","",""};
	public static String TextStatoUscitaON = "";
	public static String TextStatoUscitaOFF = "";
	public static String TextStatoInputON = "";
	public static String TextStatoInputOFF = "";

	// Carica la configurazione etichette testo
	public static void loadConfigurazioneText(Context context) {
		// Leggo configurazione etichette testo memorizzate
		SharedPreferences mySharedPreferences = context.getSharedPreferences(ConfigurazioneTextPrefs, mode);
		// Leggo la configurazione salvata
		for (int i = 1; i < 9; i++)
			TextUscite[i - 1] = mySharedPreferences.getString(("TextUscita" + i), ("Uscita Relè " + i)).trim();
		
		TextStatoUscitaON = mySharedPreferences.getString(("TextStatoUscitaON"), ("ON")).trim();
		TextStatoUscitaOFF = mySharedPreferences.getString(("TextStatoUscitaOFF"), ("OFF")).trim();
		TextStatoInputON = mySharedPreferences.getString(("TextStatoInputON"), ("ON")).trim();
		TextStatoInputOFF = mySharedPreferences.getString(("TextStatoInputOFF"), ("OFF")).trim();		
	} 

	// Salva la configurazione etichette testo
	public static void saveConfigurazioneText(Context context) {
		// Ottengo un editor per modificare le shared preferences.
		SharedPreferences mySharedPreferences = context.getSharedPreferences(ConfigurazioneTextPrefs, mode);
		SharedPreferences.Editor editor = mySharedPreferences.edit();
		// Salvo la configurazione
		for (int i = 1; i < 9; i++)
			editor.putString(("TextUscita" + i), TextUscite[i - 1].trim());
		
		editor.putString(("TextStatoUscitaON"), TextStatoUscitaON.trim());
		editor.putString(("TextStatoUscitaOFF"), TextStatoUscitaOFF.trim());
		editor.putString(("TextStatoInputON"), TextStatoInputON.trim());
		editor.putString(("TextStatoInputOFF"), TextStatoInputOFF.trim());		
		// Commit the changes.
		editor.commit();
	}
}		// Chiusura classe ConfigurazioneText