/****************************************************************
*  Name    : Control 											*
*  Author  : Ingg. Alessandro e Tommaso Giusto       			*
*  Notice  : Copyright 2012 All Rights Reserved                 *
*  Date    : 18/03/2012                                         *
*  Notes   : Classe gestione visualizzazione grafica stato     	*
*          :													*
****************************************************************/

// Definizione Package
package blackProject.ShieldIOControl;

// Inclusione librerie
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.Window;
import android.view.View.OnClickListener;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import blackProject.ShieldIOControl.BluetoothComunication;
import blackProject.ShieldIOControl.ConnessioneActivity;
import blackProject.ShieldIOControl.BTConfigActivity;
import blackProject.ShieldIOControl.StatoScheda;

// Classe Control del progetto BlueControl
public class Control extends Activity implements OnClickListener {
	// Creo nuova classe gestione protocollo bluetooth
	private BluetoothProtocol bluetoothProtocol = new BluetoothProtocol();
	
	// Classe gestione lettura/aggiornamento stato scheda
	private Lettura_StatoScheda Lettura_StatoScheda_Classe = null;
	
	// Oggetti grafici
	private TextView titleLeft = null;
	private TextView titleRight = null;
	private Button ButtonLeft = null;
	private LinearLayout LayoutLeft = null;
	private TextView TextViewShieldSelezionato = null;
	private LinearLayout LayoutRight = null;
	private Button ButtonRight = null;
	
	private TextView TextViewUscita01 = null;
	private TextView TextViewUscita02 = null;
	private TextView TextViewUscita03 = null;
	private TextView TextViewUscita04 = null;
	private TextView TextViewUscita05 = null;
	private TextView TextViewUscita06 = null;
	private TextView TextViewUscita07 = null;
	private TextView TextViewUscita08 = null;
	
	private Button ButtonReleON1 = null;
	private Button ButtonReleOFF1 = null;
	private Button ButtonReleON2 = null;
	private Button ButtonReleOFF2 = null;
	private Button ButtonReleON3 = null;
	private Button ButtonReleOFF3 = null;
	private Button ButtonReleON4 = null;
	private Button ButtonReleOFF4 = null;
	private Button ButtonReleON5 = null;
	private Button ButtonReleOFF5 = null;
	private Button ButtonReleON6 = null;
	private Button ButtonReleOFF6 = null;
	private Button ButtonReleON7 = null;
	private Button ButtonReleOFF7 = null;
	private Button ButtonReleON8 = null;
	private Button ButtonReleOFF8 = null;

	private Handler handler = new Handler();
	private Context context = this;
	
	private byte shieldSelezionatoNum = 0;
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
		// Inizializzo layout finestra
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		setContentView(R.layout.control);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.custom_title);
		
		// Azzero periferica collegata
		BluetoothComunication.devicesConnected = null;
		
		// Ottengo oggetto titolo finestra
		titleLeft = (TextView) findViewById(R.id.title_left_text);
		titleRight = (TextView) findViewById(R.id.title_right_text);
		titleLeft.setText("");

		// Ottengo oggetto titolo Shield Selezionato		
		TextViewShieldSelezionato = (TextView) findViewById(R.id.TextViewShieldSelezionato);
		TextViewShieldSelezionato.setText("");
		
		LayoutLeft = (LinearLayout) findViewById(R.id.LayoutLeft);
		LayoutRight = (LinearLayout) findViewById(R.id.LayoutRight);
		
		TextViewUscita01 = (TextView) findViewById(R.id.TextViewUscita01);
		TextViewUscita02 = (TextView) findViewById(R.id.TextViewUscita02);
		TextViewUscita03 = (TextView) findViewById(R.id.TextViewUscita03);
		TextViewUscita04 = (TextView) findViewById(R.id.TextViewUscita04);
		TextViewUscita05 = (TextView) findViewById(R.id.TextViewUscita05);
		TextViewUscita06 = (TextView) findViewById(R.id.TextViewUscita06);
		TextViewUscita07 = (TextView) findViewById(R.id.TextViewUscita07);
		TextViewUscita08 = (TextView) findViewById(R.id.TextViewUscita08);

		// Identifico pulsanti
		ButtonLeft = (Button) findViewById(R.id.ButtonLeft);
		ButtonRight = (Button) findViewById(R.id.ButtonRight);
    	ButtonReleON1 = (Button) findViewById(R.id.ButtonReleON1);
    	ButtonReleOFF1 = (Button) findViewById(R.id.ButtonReleOFF1);
    	ButtonReleON2 = (Button) findViewById(R.id.ButtonReleON2);
    	ButtonReleOFF2 = (Button) findViewById(R.id.ButtonReleOFF2);
    	ButtonReleON3 = (Button) findViewById(R.id.ButtonReleON3);
    	ButtonReleOFF3 = (Button) findViewById(R.id.ButtonReleOFF3);
    	ButtonReleON4 = (Button) findViewById(R.id.ButtonReleON4);
    	ButtonReleOFF4 = (Button) findViewById(R.id.ButtonReleOFF4);
    	ButtonReleON5 = (Button) findViewById(R.id.ButtonReleON5);
    	ButtonReleOFF5 = (Button) findViewById(R.id.ButtonReleOFF5);
    	ButtonReleON6 = (Button) findViewById(R.id.ButtonReleON6);
    	ButtonReleOFF6 = (Button) findViewById(R.id.ButtonReleOFF6);
    	ButtonReleON7 = (Button) findViewById(R.id.ButtonReleON7);
    	ButtonReleOFF7 = (Button) findViewById(R.id.ButtonReleOFF7);
    	ButtonReleON8 = (Button) findViewById(R.id.ButtonReleON8);
    	ButtonReleOFF8 = (Button) findViewById(R.id.ButtonReleOFF8);
    	
		ButtonLeft.setOnClickListener(this);
		ButtonRight.setOnClickListener(this);
    	ButtonReleON1.setOnClickListener(this);
    	ButtonReleOFF1.setOnClickListener(this);
    	ButtonReleON2.setOnClickListener(this);
    	ButtonReleOFF2.setOnClickListener(this);
    	ButtonReleON3.setOnClickListener(this);
    	ButtonReleOFF3.setOnClickListener(this);
    	ButtonReleON4.setOnClickListener(this);
    	ButtonReleOFF4.setOnClickListener(this);
    	ButtonReleON5.setOnClickListener(this);
    	ButtonReleOFF5.setOnClickListener(this);
    	ButtonReleON6.setOnClickListener(this);
    	ButtonReleOFF6.setOnClickListener(this);
    	ButtonReleON7.setOnClickListener(this);
    	ButtonReleOFF7.setOnClickListener(this);
    	ButtonReleON8.setOnClickListener(this);
    	ButtonReleOFF8.setOnClickListener(this);
    	
    	// Carico la configurazione etichette testo
        ConfigurazioneText.loadConfigurazioneText(context);    	
    	
		// Avvio thread aggiornamento grafica
		Aggiornamento_Grafica();

		// Avvvio activity DeviceListActivity per selezionare periferica
		Intent serverIntent = new Intent(this, ConnessioneActivity.class);
		startActivityForResult(serverIntent, 0);    	
    }		// Chiusura funzione onCreate

    // Eseguita quando l'activity viene visualizzata
    @Override
    public void onResume() {
    	super.onResume();
    	
    	// Azzero strutture memorizzazione stato scheda
    	StatoScheda.ResetStatoScheda();
    	
    	// Avvio thread lettura stato scheda
		Lettura_StatoScheda_Classe = new Lettura_StatoScheda();    	
    }		// Chiusura funzione onResume

    // Eseguita quando l'activity viene nascosta
	@Override
	public void onPause() {
		// Termino thread lettura stato scheda
		try {
			Lettura_StatoScheda_Classe.stopRunning();
		} catch (Exception e) {}
		
		super.onPause();
	}		// Chiusura funzione onPause

    // Eseguita quando l'activity viene terminata
    @Override
    public void onDestroy() {
		// Termino thread lettura stato scheda
		try {
			Lettura_StatoScheda_Classe.stopRunning();
		} catch (Exception e) {}

		// Azzero classe gestione protocollo bluetooth
		bluetoothProtocol = null;

		super.onDestroy();
    }		// Chiusura funzione onDestroy
    
	// Definizione classe Lettura_StatoScheda
	public class Lettura_StatoScheda implements Runnable {
		private Thread Lettura_StatoScheda_Thread = null;
		private boolean Termina_Thread = false;

		// Costruttore classe Lettura_StatoScheda
		private Lettura_StatoScheda() {
			Lettura_StatoScheda_Thread = new Thread(this);
			Lettura_StatoScheda_Thread.start();
		}		// Chiusura costruttore classe Lettura_StatoScheda

		// Funzione esecuzione lettura stato scheda
		public void run() {
			byte Risposta[] = new byte[22];
			
			// Mentre thread non bloccato
			for (;(Termina_Thread == false);) {
				// Se selezionato un dispositivo
				if (BluetoothComunication.devicesConnected != null) {
					// Se richiesta lettura dello stato scheda (GET STATUS) OK
					if (bluetoothProtocol.LetturaStatoScheda (Risposta) == true) {
						// Estraggo informazioni ricevute
						if (StatoScheda.StatoUsciteRele == null) {
							StatoScheda.StatoUsciteRele = new byte[StatoScheda.MAXIOExpanderShield];
							StatoScheda.StatoIngressiDigitali = new byte[StatoScheda.MAXIOExpanderShield];
						}
						
						StatoScheda.IOExpanderRilevati = (byte) (Risposta[0]);

						// Se shield visualizzato non rilevato
						if (StatoScheda.IOExpanderRilevato(shieldSelezionatoNum) == false)
							// Aggiorno variabile numero shield selezionato
							shieldSelezionatoNum = StatoScheda.prossimoIOExpanderRilevato(shieldSelezionatoNum);

						for (byte i = 0; i < StatoScheda.MAXIOExpanderShield; i++) {
							StatoScheda.StatoUsciteRele[i] = (byte) (Risposta[1 + (i * 2)]);
							StatoScheda.StatoIngressiDigitali[i] = (byte) (Risposta[2 + (i * 2)]);		
						}
					}		// Chiusura if richiesta lettura dello stato scheda (GET STATUS) OK
					
					// Se richiesta lettura dello stato scheda (GET STATUS) FAULT
					else
						// Resetto stato scheda
						StatoScheda.ResetStatoScheda();
				}		// Chiusura if selezionato un dispositivo

				// Aggiornamento stato scheda
				Aggiornamento_Grafica();
				
				try {
					Thread.sleep (5000);
				} catch (Exception e) {}
			}		// Chiusura ciclo for mentre thread non bloccato
		}		// Chiusura funzione run
		
		// Richiede il termine del thread
		public void stopRunning() {
			Termina_Thread = true;
		}		// Chiusura funzione stopRunning
	}		// Chiusura classe Lettura_StatoScheda
	
	// Definizione classe AttivazioneRele
	private class AttivazioneRele implements Runnable {
		private Thread AttivazioneRele_Thread = null;
		private byte ReleNum;

		// Costruttore classe AttivazioneRele
		private AttivazioneRele (byte ReleNumTMP) {
			ReleNum = ReleNumTMP;
			AttivazioneRele_Thread = new Thread(this);
			AttivazioneRele_Thread.start();
		}		// Chiusura costruttore classe AttivazioneRele

		// Funzione esecuzione attivazione rele
		public void run() {
			boolean Risposta;

			// Visualizzo dialog di progresso
			Utility.ShowProgressDialog("", "Esecuzione comando in corso...", context, handler);
			
			// Eseguo richiesta attivazione rele
			Risposta = bluetoothProtocol.AttivazioneRele (shieldSelezionatoNum, ReleNum);
			
			// Nascondo barra di progresso
			Utility.HideProgressDialog();
			
			// Se richiesta attivazione rele OK
			if (Risposta == true)
				StatoScheda.ImpostaStatoUscitaRele(shieldSelezionatoNum, ReleNum, true);
			else
				// Segnalo errore
				Utility.ShowSimpleDialog("Attenzione",
										 "Esecuzione del comando non riuscita",
										 R.drawable.iconaerrorealert, context, handler, null, null);			
			
			// Aggiornamento stato scheda
			Aggiornamento_Grafica();
		}		// Chiusura funzione run
	}		// Chiusura classe AttivazioneRele
	
	// Definizione classe DisattivazioneRele
	private class DisattivazioneRele implements Runnable {
		private Thread DisattivazioneRele_Thread = null;
		private byte ReleNum;

		// Costruttore classe DisattivazioneRele
		private DisattivazioneRele (byte ReleNumTMP) {
			ReleNum = ReleNumTMP;
			DisattivazioneRele_Thread = new Thread(this);
			DisattivazioneRele_Thread.start();
		}		// Chiusura costruttore classe AttivazioneRele

		// Funzione esecuzione attivazione rele
		public void run() {
			boolean Risposta;

			// Visualizzo dialog di progresso
			Utility.ShowProgressDialog("", "Esecuzione comando in corso...", context, handler);
			
			// Eseguo richiesta disattivazione rele
			Risposta = bluetoothProtocol.DisattivazioneRele (shieldSelezionatoNum, ReleNum);
			
			// Nascondo barra di progresso
			Utility.HideProgressDialog();
			
			// Se richiesta disattivazione rele OK
			if (Risposta == true)
				StatoScheda.ImpostaStatoUscitaRele(shieldSelezionatoNum, ReleNum, false);
			else
				// Segnalo errore
				Utility.ShowSimpleDialog("Attenzione",
										 "Esecuzione del comando non riuscita",
										 R.drawable.iconaerrorealert, context, handler, null, null);	
			
			// Aggiornamento stato scheda
			Aggiornamento_Grafica();
		}		// Chiusura funzione run
	}		// Chiusura classe DisattivazioneRele

	// Funzione richiamata quando viene premuto un pulsante
	public void onClick(View target) {		
		// Seleziono ID pulsante premuto
		switch (target.getId()) {
			case R.id.ButtonLeft:
				// 	Rilevo precedente shield rilevato
				shieldSelezionatoNum = StatoScheda.precedenteIOExpanderRilevato(shieldSelezionatoNum);
				break;
			case R.id.ButtonRight:
				// 	Rilevo prossimo shield rilevato
				shieldSelezionatoNum = StatoScheda.prossimoIOExpanderRilevato(shieldSelezionatoNum);
				break;			

			case R.id.ButtonReleON1:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (0));    	
				break;
			case R.id.ButtonReleOFF1:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (0));    	
				break;

			case R.id.ButtonReleON2:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (1));    	
				break;
			case R.id.ButtonReleOFF2:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (1));    	
				break;

			case R.id.ButtonReleON3:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (2));    	
				break;
			case R.id.ButtonReleOFF3:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (2));    	
				break;

			case R.id.ButtonReleON4:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (3));    	
				break;
			case R.id.ButtonReleOFF4:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (3));    	
				break;

			case R.id.ButtonReleON5:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (4));    	
				break;
			case R.id.ButtonReleOFF5:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (4));    	
				break;

			case R.id.ButtonReleON6:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (5));    	
				break;
			case R.id.ButtonReleOFF6:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (5));    	
				break;

			case R.id.ButtonReleON7:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (6));    	
				break;
			case R.id.ButtonReleOFF7:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (6));    	
				break;

			case R.id.ButtonReleON8:
		    	// Avvio thread attivazione rele
				new AttivazioneRele ((byte) (7));    	
				break;
			case R.id.ButtonReleOFF8:
		    	// Avvio thread disattivazione rele
				new DisattivazioneRele ((byte) (7));    	
				break;				
		}		// Chiusura switch seleziono ID pulsante premuto
	}		// Chiusura funzione onClick

	// Funzione aggiornamento stato scheda
	private void Aggiornamento_Grafica() {
		// Avvio thread aggiornamento grafica
		handler.post(AggiornamentoGrafica);
	}		// Chiusura funzione Aggiornamento_Grafica

    // Classe gestione aggiornamento grafica
	// INPUT:	-
	// OUTPUT:	-
	// Note:	-
	private Runnable AggiornamentoGrafica = new Runnable() {
		// Funzione esecuzione aggiornamento grafica
		public void run() {
			try {
		    	// Imposto la configurazione etichette testo
		        TextViewUscita01.setText(ConfigurazioneText.TextUscite[0]);
		        TextViewUscita02.setText(ConfigurazioneText.TextUscite[1]);
		        TextViewUscita03.setText(ConfigurazioneText.TextUscite[2]);
		        TextViewUscita04.setText(ConfigurazioneText.TextUscite[3]);
		        TextViewUscita05.setText(ConfigurazioneText.TextUscite[4]);
		        TextViewUscita06.setText(ConfigurazioneText.TextUscite[5]);
		        TextViewUscita07.setText(ConfigurazioneText.TextUscite[6]);
		        TextViewUscita08.setText(ConfigurazioneText.TextUscite[7]); 				

		        // Visualizzo nome scheda
				if (BluetoothComunication.devicesConnected != null) {
					titleRight.setText ("Collegato a: " + BluetoothComunication.devicesConnected.getName());
				}
				else {
					titleRight.setText("Disconnesso");
					TextViewShieldSelezionato.setText("");
				}

				// Se selezionato un dispositivo AND ultima richiesta bluetooth completata AND selezionato uno shield 
				if ((BluetoothComunication.devicesConnected != null) &&
					(StatoScheda.RisultatoUltimaComunicazione == true) && (shieldSelezionatoNum != -1)) {
					
					// Se identificati pi IO Expander
					if (StatoScheda.NumeroIOExpanderRilevati() > 1) {
						ButtonLeft.setVisibility(View.VISIBLE);
						ButtonRight.setVisibility(View.VISIBLE);	
						LayoutLeft.setVisibility(View.VISIBLE);
						LayoutRight.setVisibility(View.VISIBLE);
					}
					// Se identificato un solo IO Expander
					else {
						ButtonLeft.setVisibility(View.GONE);
						ButtonRight.setVisibility(View.GONE);
						LayoutLeft.setVisibility(View.GONE);
						LayoutRight.setVisibility(View.GONE);
					}
					
					// Aggiorno grafica shield selezionato
					TextViewShieldSelezionato.setText("Shield numero: " + shieldSelezionatoNum);
					
					for (byte UscitaNum = 0; UscitaNum < 8; UscitaNum++)
						AggiornaGraficaUscita (UscitaNum);
					
					for (byte InputNum = 0; InputNum < 8; InputNum++)
						AggiornaGraficaDigitalInput (InputNum);
				}		// Chiusura if selezionato un dispositivo AND ultima richiesta bluetooth completata AND selezionato uno shield
	
				// Se ultima richiesta bluetooth FAULT
				else {
					ButtonLeft.setVisibility(View.GONE);
					ButtonRight.setVisibility(View.GONE);
					LayoutLeft.setVisibility(View.GONE);
					LayoutRight.setVisibility(View.GONE);

					// Aggiorno grafica shield selezionato
					if (shieldSelezionatoNum == -1)
						TextViewShieldSelezionato.setText("Nessuno shield rilevato");
					else
						TextViewShieldSelezionato.setText("");
					
					// Disabilito campi grafici uscite
					for (byte UscitaNum = 0; UscitaNum < 8; UscitaNum++)
						DisabilitaGraficaUscita (UscitaNum);
					
					for (byte InputNum = 0; InputNum < 8; InputNum++)
						DisabilitaGraficaDigitalInput (InputNum);
				}		// Chiusura else ultima richiesta bluetooth FAULT
			} catch (Exception e) {}
		}		// Chiusura funzione run
	};		// Chiusura classe AggiornamentoGrafica
	
	// Aggiorna tutti i campi grafici di una uscita (rele/potenza/led)
	private void AggiornaGraficaUscita (byte UscitaNum) {
		TextView TextViewStatoUscita = null;
		Button ButtonUscitaON = null;
		Button ButtonUscitaOFF = null;
			
		try {
			// Identifico oggetti grafici
			switch (UscitaNum) {
				case (byte) (0x00):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele1);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON1);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF1);
					break;
				case (byte) (0x01):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele2);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON2);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF2);
					break;
				case (byte) (0x02):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele3);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON3);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF3);
					break;
				case (byte) (0x03):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele4);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON4);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF4);
					break;
				case (byte) (0x04):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele5);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON5);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF5);
					break;
				case (byte) (0x05):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele6);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON6);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF6);
					break;
				case (byte) (0x06):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele7);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON7);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF7);
					break;
				case (byte) (0x07):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele8);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON8);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF8);
					break;
			}
			
			ButtonUscitaON.setText (ConfigurazioneText.TextStatoUscitaON);
			ButtonUscitaOFF.setText (ConfigurazioneText.TextStatoUscitaOFF);			
			
			// Se uscita rele attiva
			if (StatoScheda.UscitaReleAttiva(shieldSelezionatoNum, UscitaNum) == true) {
				TextViewStatoUscita.setText (ConfigurazioneText.TextStatoUscitaON);
				ButtonUscitaON.setVisibility(View.GONE);
				ButtonUscitaOFF.setVisibility(View.VISIBLE);
				ButtonUscitaON.setEnabled(false);
				ButtonUscitaOFF.setEnabled(true);				
			}
			// Se uscita rele disattiva
			else {
				TextViewStatoUscita.setText (ConfigurazioneText.TextStatoUscitaOFF);
				ButtonUscitaON.setVisibility(View.VISIBLE);
				ButtonUscitaOFF.setVisibility(View.GONE);
				ButtonUscitaON.setEnabled(true);
				ButtonUscitaOFF.setEnabled(false);
			}
		} catch (Exception e) {}
	}		// Chiusura funzione AggiornaGraficaUscita

	// Disabilita tutti i campi grafici di una uscita (rele/potenza/led)
	private void DisabilitaGraficaUscita (byte UscitaNum) {
		TextView TextViewStatoUscita = null;
		Button ButtonUscitaON = null;
		Button ButtonUscitaOFF = null;
		
		try {
			// Identifico oggetti grafici
			switch (UscitaNum) {
				case (byte) (0x00):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele1);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON1);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF1);
					break;
				case (byte) (0x01):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele2);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON2);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF2);
					break;
				case (byte) (0x02):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele3);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON3);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF3);
					break;
				case (byte) (0x03):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele4);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON4);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF4);
					break;
				case (byte) (0x04):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele5);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON5);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF5);
					break;
				case (byte) (0x05):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele6);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON6);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF6);
					break;
				case (byte) (0x06):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele7);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON7);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF7);
					break;
				case (byte) (0x07):
					TextViewStatoUscita = (TextView) findViewById(R.id.TextViewStatoRele8);
					ButtonUscitaON = (Button) findViewById(R.id.ButtonReleON8);
					ButtonUscitaOFF = (Button) findViewById(R.id.ButtonReleOFF8);
					break;
			}
			
			ButtonUscitaON.setText (ConfigurazioneText.TextStatoUscitaON);
			ButtonUscitaOFF.setText (ConfigurazioneText.TextStatoUscitaOFF);			
	
			TextViewStatoUscita.setText ("");
			ButtonUscitaON.setVisibility(View.VISIBLE);
			ButtonUscitaOFF.setVisibility(View.GONE);			
			ButtonUscitaON.setEnabled (false);
			ButtonUscitaOFF.setEnabled (false);
		} catch (Exception e) {}
	}		// Chiusura funzione DisabilitaGraficaUscita

	// Aggiorna tutti i campi grafici di un ingresso digitale
	private void AggiornaGraficaDigitalInput (byte InputNum) {
		TextView TextViewStatoDigitalInput = null;
		
		try {
			// Identifico oggetti grafici
			switch (InputNum) {
				case (byte) (0x00):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig1);
					break;
				case (byte) (0x01):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig2);
					break;
				case (byte) (0x02):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig3);
					break;
				case (byte) (0x03):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig4);
					break;
				case (byte) (0x04):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig5);
					break;
				case (byte) (0x05):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig6);
					break;
				case (byte) (0x06):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig7);
					break;
				case (byte) (0x07):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig8);
					break;
			}
			
			// Se ingresso attivo
			if (StatoScheda.IngressoDigitaleAttivo(shieldSelezionatoNum, InputNum) == true)
				TextViewStatoDigitalInput.setText (ConfigurazioneText.TextStatoInputON);
			// Se ingresso disattivo
			else
				TextViewStatoDigitalInput.setText (ConfigurazioneText.TextStatoInputOFF);
		} catch (Exception e) {}
	}		// Chiusura funzione AggiornaGraficaDigitalInput

	// Disabilita tutti i campi grafici di un ingresso digitale
	private void DisabilitaGraficaDigitalInput (byte InputNum) {
		TextView TextViewStatoDigitalInput = null;
		
		try {
			// Identifico oggetti grafici
			switch (InputNum) {
				case (byte) (0x00):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig1);
					break;
				case (byte) (0x01):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig2);
					break;
				case (byte) (0x02):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig3);
					break;
				case (byte) (0x03):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig4);
					break;
				case (byte) (0x04):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig5);
					break;
				case (byte) (0x05):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig6);
					break;
				case (byte) (0x06):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig7);
					break;
				case (byte) (0x07):
					TextViewStatoDigitalInput = (TextView) findViewById(R.id.TextViewStatoDig8);
					break;
			}
	
			TextViewStatoDigitalInput.setText ("");
		} catch (Exception e) {}
	}		// Chiusura funzione DisabilitaGraficaDigitalInput

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.option_menu, menu);
		return (true);
	}
	
	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {
		super.onPrepareOptionsMenu(menu);
		
		// Se periferica collegata azzerata
		if (BluetoothComunication.devicesConnected == null) {
			menu.findItem(R.id.Connect).setVisible(true);
			menu.findItem(R.id.BTConfig).setVisible(false);
		}
		else {
			menu.findItem(R.id.Connect).setVisible(false);
			menu.findItem(R.id.BTConfig).setVisible(true);
		}

		// Termino funzione
		return (true);
	}		// Chiusura funzione onPrepareOptionsMenu

	// Richiamata quando viene selezionata una voce del men
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Seleziono voce men premuta
		switch (item.getItemId()) {
			// Se selezionata voce connessione
			case R.id.Connect:
				// Avvio activity ConnessioneActivity
				Intent ConnessioneIntent = new Intent(this, ConnessioneActivity.class);
				startActivityForResult(ConnessioneIntent, 0);
				// Termino funzione
				return (true);

			// Se selezionata voce BT Config
			case R.id.BTConfig:
				// Avvvio activity BTConfigActivity
				Intent BTConfigIntent = new Intent(this, BTConfigActivity.class);
				startActivityForResult(BTConfigIntent, 0);
				// Termino funzione
				return (true);
				
			// Se selezionata voce Text Config
			case R.id.TextConfig:
				// Avvvio activity TextConfigActivity
				Intent TextConfigIntent = new Intent(this, TextConfigActivity.class);
				startActivityForResult(TextConfigIntent, 0);
				// Avvio thread aggiornamento grafica
				Aggiornamento_Grafica();
				// Termino funzione
				return (true);
		}		// Chiusura switch seleziono voce men premuta
		return (false);
	}		// Chiusura funzione onOptionsItemSelected
}		// Chiusura classe Control