/****************************************************************
*  Name    : ShieldIOControlActivity							*
*  Author  : Ingg. Alessandro e Tommaso Giusto       			*
*  Notice  : Copyright 2013 All Rights Reserved                 *
*  Date    : 29/09/2013                                         *
*  Notes   : Classe principale del progetto					    *
*          :													*
****************************************************************/

// Definizione Package
package blackProject.ShieldIOControl;

// Inclusione librerie
import java.util.Timer;
import java.util.TimerTask;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;

// Definizione classe ShieldIOControl
public class ShieldIOControl extends Activity {
    // Oggetto Bluetooth adapter
    private BluetoothAdapter bluetoothAdapter = null;	
	
	private Timer RimuoviSplashScreenTimer = null;

	private Handler handler = new Handler();
	private Context context = this;

	// Eseguita quando l'activity viene creata per la prima volta
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
		// Verifico disponibilit bluetooth
		bluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		// Se bluetooth disponibile
		if (bluetoothAdapter != null) {
	    	// Creo/Avvio timer rimozione splashscreen e visualizzazione TabMenu
	    	RimuoviSplashScreenTimer = new Timer();
	    	RimuoviSplashScreenTimer.schedule (new TimerTask() {
				@Override
				public void run() {
					RimuoviSplashScreen();
			 	}
			}, 2500);
		}		// Chiusura if bluetooth disponibile
		// Se bluetooth non disponibile
		else
			// Segnalo errore
			Utility.ShowSimpleDialog ("Attenzione",
									  "Buetooth non disponibile",
									  R.drawable.iconaerrorealert, context, handler,
									  new DialogInterface.OnClickListener() {
									  		public void onClick (DialogInterface dialog, int arg1) {
									  			// Termino activity
					  							finish();
											}
									  },
									  new DialogInterface.OnCancelListener() {
									  		public void onCancel (DialogInterface dialog) {
									  			// Termino activity
					  							finish();
											}
									  });
    }		// Chiusura funzione onCreate
    
	// Eseguita quando l'activity viene terminata
	@Override
	public void onDestroy() {
		// Termino timer aggiornamento stato scheda
		try {
			RimuoviSplashScreenTimer.purge();
			RimuoviSplashScreenTimer.cancel();
		} catch (Exception e) {}
		
		// Azzero oggetto bluetooth adapter
		bluetoothAdapter = null;

		super.onDestroy();
	}		// Chiusura funzione onDestroy
    
	// Rimozione splashscreen e visualizzazione finestra tabmenu
    void RimuoviSplashScreen() {
        // Avvio activity Control
		Intent intent = new Intent (this, Control.class);
       	startActivity (intent);
   		// Termino activity
   		finish();
    }		// Chiusura funzione RimuoviSplashScreen
}		// Chiusura classe ShieldIOControl