/****************************************************************
*  Name    : TextConfigActivity						   			*
*  Author  : Davide Ferrario				          			*
*  Notice  : Copyright 2012 All Rights Reserved                 *
*  Date    : 19/02/2012                                         *
*  Notes   : Classe TextConfigActivity del progetto 			*
*          :													*
****************************************************************/

// Definizione Package
package blackProject.ShieldIOControl;

//Inclusione librerie
import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

//Definizione classe TextConfigActivity
public class TextConfigActivity extends Activity implements OnClickListener {	
	// Oggetti grafici
	private EditText EditTextUscita01 = null;
	private EditText EditTextUscita02 = null;
	private EditText EditTextUscita03 = null;
	private EditText EditTextUscita04 = null;
	private EditText EditTextUscita05 = null;
	private EditText EditTextUscita06 = null;
	private EditText EditTextUscita07 = null;
	private EditText EditTextUscita08 = null;
	
	private EditText EditTextStatoUscitaON = null;
	private EditText EditTextStatoUscitaOFF = null;
	private EditText EditTextStatoInputON = null;
	private EditText EditTextStatoInputOFF = null;	
		
	private Button ButtonOK = null;
	private Button ButtonDefault = null;
	
	private Handler handler = new Handler();
	private Context context = this;

	// Eseguita quando l'activity viene creata per la prima volta
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // Inizializzo finestra
        requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);
        setContentView(R.layout.textconfig);
        
		// Ottengo oggetti grafici finestra
        EditTextUscita01 = (EditText) findViewById(R.id.EditTextUscita01);
        EditTextUscita02 = (EditText) findViewById(R.id.EditTextUscita02);
        EditTextUscita03 = (EditText) findViewById(R.id.EditTextUscita03);
        EditTextUscita04 = (EditText) findViewById(R.id.EditTextUscita04);
        EditTextUscita05 = (EditText) findViewById(R.id.EditTextUscita05);
        EditTextUscita06 = (EditText) findViewById(R.id.EditTextUscita06);
        EditTextUscita07 = (EditText) findViewById(R.id.EditTextUscita07);
        EditTextUscita08 = (EditText) findViewById(R.id.EditTextUscita08);
        
        EditTextStatoUscitaON = (EditText) findViewById(R.id.EditTextStatoUscitaON);
        EditTextStatoUscitaOFF = (EditText) findViewById(R.id.EditTextStatoUscitaOFF);        
        EditTextStatoInputON = (EditText) findViewById(R.id.EditTextStatoInputON);
        EditTextStatoInputOFF = (EditText) findViewById(R.id.EditTextStatoInputOFF);        
        
		// Identifico pulsanti
		ButtonOK = (Button) findViewById(R.id.ButtonOK);
		ButtonDefault = (Button) findViewById(R.id.ButtonDefault);

		// Imposto la configurazione etichette testo
        EditTextUscita01.setText(ConfigurazioneText.TextUscite[0]);
        EditTextUscita02.setText(ConfigurazioneText.TextUscite[1]);
        EditTextUscita03.setText(ConfigurazioneText.TextUscite[2]);
        EditTextUscita04.setText(ConfigurazioneText.TextUscite[3]);
        EditTextUscita05.setText(ConfigurazioneText.TextUscite[4]);
        EditTextUscita06.setText(ConfigurazioneText.TextUscite[5]);
        EditTextUscita07.setText(ConfigurazioneText.TextUscite[6]);
        EditTextUscita08.setText(ConfigurazioneText.TextUscite[7]);
        
        EditTextStatoUscitaON.setText(ConfigurazioneText.TextStatoUscitaON);
        EditTextStatoUscitaOFF.setText(ConfigurazioneText.TextStatoUscitaOFF);
        EditTextStatoInputON.setText(ConfigurazioneText.TextStatoInputON);
        EditTextStatoInputOFF.setText(ConfigurazioneText.TextStatoInputOFF);
        
        ButtonOK.setOnClickListener(this);
        ButtonDefault.setOnClickListener(this);
    }		// Chiusura funzione onCreate

    // Eseguita quando l'activity viene terminata
    @Override
    protected void onDestroy() {
		super.onDestroy();
    }		// Chiusura funzione onDestroy

    // Funzione richiamata quando viene premuto un pulsante
	public void onClick(View target) {		
		// Seleziono ID pulsante premuto
		switch (target.getId()) {
			case R.id.ButtonOK:
				// Memorizzo la configurazione etichette testo
				ConfigurazioneText.TextUscite[0] = EditTextUscita01.getText().toString().trim();
				ConfigurazioneText.TextUscite[1] = EditTextUscita02.getText().toString().trim();
				ConfigurazioneText.TextUscite[2] = EditTextUscita03.getText().toString().trim();
				ConfigurazioneText.TextUscite[3] = EditTextUscita04.getText().toString().trim();
				ConfigurazioneText.TextUscite[4] = EditTextUscita05.getText().toString().trim();
				ConfigurazioneText.TextUscite[5] = EditTextUscita06.getText().toString().trim();
				ConfigurazioneText.TextUscite[6] = EditTextUscita07.getText().toString().trim();
				ConfigurazioneText.TextUscite[7] = EditTextUscita08.getText().toString().trim();
				
				ConfigurazioneText.TextStatoUscitaON = EditTextStatoUscitaON.getText().toString().trim();
				ConfigurazioneText.TextStatoUscitaOFF = EditTextStatoUscitaOFF.getText().toString().trim();
				ConfigurazioneText.TextStatoInputON = EditTextStatoInputON.getText().toString().trim();
				ConfigurazioneText.TextStatoInputOFF = EditTextStatoInputOFF.getText().toString().trim();				
			
				// Salvo configurazione etichette testo
				ConfigurazioneText.saveConfigurazioneText(context);

				// Termino activity
				finish();
				break;
				
			case R.id.ButtonDefault:
		        EditTextUscita01.setText("Uscita Relè 1");
		        EditTextUscita02.setText("Uscita Relè 2");
		        EditTextUscita03.setText("Uscita Relè 3");
		        EditTextUscita04.setText("Uscita Relè 4");
		        EditTextUscita05.setText("Uscita Relè 5");
		        EditTextUscita06.setText("Uscita Relè 6");
		        EditTextUscita07.setText("Uscita Relè 7");
		        EditTextUscita08.setText("Uscita Relè 8");
		        
		        EditTextStatoUscitaON.setText("ON");
		        EditTextStatoUscitaOFF.setText("OFF");
		        EditTextStatoInputON.setText("ON");
		        EditTextStatoInputOFF.setText("OFF");
				break;
		}		// Chiusura switch seleziono ID pulsante premuto
	}		// Chiusura funzione onClick
}		// Chiusura classe TextConfigActivity